CodeForces - 711C Coloring Trees【给树染色】

来源:互联网 发布:finalcut mac 编辑:程序博客网 时间:2024/06/08 01:36

Problem
ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.
Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.
ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.
The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.
ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.
Please note that the friends can’t color the trees that are already colored.

Input
The first line contains three integers, n, m and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.
The second line contains n integers c1, c2, …, cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.
Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color j. pi, j’s are specified even for the initially colored trees, but such trees still can’t be colored.

Output
Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Example
Input
3 2 2
0 0 0
1 2
3 4
5 6
Output
10
Input
3 2 2
2 1 2
1 3
2 4
3 5
Output
-1
Input
3 2 2
2 0 0
1 3
2 4
3 5
Output
5
Input
3 2 3
2 1 2
1 3
2 4
3 5
Output
0

Note
In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).
In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is  - 1.
In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

思路:
m,n,k都很小,且问结果不问过程,可以尝试动态规划
dp[i][j][k]表示将第i棵树为j颜色而美丽度为k时油漆的最小消耗。

AC代码:

#include <iostream>#include <cstdio>  #include <cstring>  #include <cstdlib>#include <cmath>#include <algorithm> using namespace std; long long tree[105], cost[105][105], dp[105][105][105]; int main()  {      long long n, m, k0;      cin >> n >> m >> k0;      for(int i = 1; i <= n; i++){          cin >> tree[i];      }      for(int i = 1; i <= n; i++){          for(int j = 1; j <= m; j++){              cin >> cost[i][j];          }      }      for(int i = 0; i <= n + 1; i++){          for(int  j = 0; j <= m + 1; j++){              for(int k = 0; k <= k0 + 1; k++){                  dp[i][j][k] = 9e18;              }          }      }      int i, j, k, y;      for(i = 1; i <= n; i++){          for(k = 1; k <= k0; k++){              if(k > i) break;              if(tree[i] != 0){                  if(i == 1){                      dp[1][tree[i]][1] = 0;                      continue;                  }                dp[i][tree[i]][k] = dp[i-1][tree[i]][k];                  for(j = 1; j <= m; j++){                      if(tree[i] == j)  continue;                      else dp[i][tree[i]][k] = min(dp[i][tree[i]][k], dp[i - 1][j][k - 1]);                  }              }            else{                  if(i == 1){                      for(j = 1; j <= m; j++){                          dp[i][j][1] = cost[1][j];                      }                      continue;                  }                for(j = 1; j <= m; j++){                      dp[i][j][k] = dp[i - 1][j][k] + cost[i][j];                      for(y = 1; y <= m; y++){                          if(j == y) continue;                          else dp[i][j][k] = min(dp[i][j][k], dp[i - 1][y][k - 1] + cost[i][j]);                      }                }              }          }      }    long long ans = 9e18;      for(j = 1; j <= m; j++){          ans = min(ans, dp[n][j][k0]);      }      if(ans == 9e18) printf("-1\n");      else printf("%lld\n", ans);    return 0;  }  

也可以单独存两个二维数组:a[j][k] = dp[i][j][k],b[j][k] = dp[i+1][j][k],然后a数组和b数组交换记录

1 0
原创粉丝点击